/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.filters.Threshold;

import java.util.Vector;
import org.visnow.jscic.dataarrays.DataArray;
import org.visnow.jscic.Field;

/**
 * @author Bartosz Borucki (babor@icm.edu.pl)
 * Warsaw University, Interdisciplinary Centre
 * for Mathematical and Computational Modelling
 */
public class GUI extends javax.swing.JPanel
{

    private Params params = new Params();
    private Field inField = null;
    private int[] scalarCompIndices = null;
    private String[] scalarCompNames = null;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        lowValCheckBox = new javax.swing.JCheckBox();
        jPanel1 = new javax.swing.JPanel();
        thresholdSlider = new org.visnow.vn.gui.widgets.FloatSubRangeSlider.ExtendedFloatSubRangeSlider();
        upValCheckBox = new javax.swing.JCheckBox();
        invalidateCB = new javax.swing.JCheckBox();
        runButton = new javax.swing.JButton();
        thresholdComponentChooser = new org.visnow.vn.lib.gui.DataComponentSelector();

        setMinimumSize(new java.awt.Dimension(184, 155));
        setPreferredSize(new java.awt.Dimension(224, 241));
        setLayout(new java.awt.GridBagLayout());

        lowValCheckBox.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        lowValCheckBox.setSelected(true);
        lowValCheckBox.setText("set values below threshold to global min ");
        lowValCheckBox.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lowValCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 0, 0);
        add(lowValCheckBox, gridBagConstraints);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

        thresholdSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "thresholding range", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(thresholdSlider, gridBagConstraints);

        upValCheckBox.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        upValCheckBox.setSelected(true);
        upValCheckBox.setText("set values above threshold to global max");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 0);
        add(upValCheckBox, gridBagConstraints);

        invalidateCB.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        invalidateCB.setSelected(true);
        invalidateCB.setText("invalidate points outside range");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 0);
        add(invalidateCB, gridBagConstraints);

        runButton.setText("Run");
        runButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(runButton, gridBagConstraints);

        thresholdComponentChooser.setBorder(javax.swing.BorderFactory.createTitledBorder("threshold component"));
        thresholdComponentChooser.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                thresholdComponentChooserStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(thresholdComponentChooser, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void thresholdComponentChooserStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_thresholdComponentChooserStateChanged
        updateThrSlider();
    }//GEN-LAST:event_thresholdComponentChooserStateChanged

    private void runButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runButtonActionPerformed
        params.setComponent(thresholdComponentChooser.getComponent());
        params.setLowerThreshold(thresholdSlider.getLow());
        params.setUpperThreshold(thresholdSlider.getUp());
        params.setLowToMin(lowValCheckBox.isSelected());        
        params.setUpToMax(upValCheckBox.isSelected());
        params.setInvalidate(invalidateCB.isSelected());        
        params.fireStateChanged();
    }//GEN-LAST:event_runButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox invalidateCB;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JCheckBox lowValCheckBox;
    private javax.swing.JButton runButton;
    private org.visnow.vn.lib.gui.DataComponentSelector thresholdComponentChooser;
    private org.visnow.vn.gui.widgets.FloatSubRangeSlider.ExtendedFloatSubRangeSlider thresholdSlider;
    private javax.swing.JCheckBox upValCheckBox;
    // End of variables declaration//GEN-END:variables
    public void setParams(Params params)
    {
        this.params = params;
    }

    public void setInField(Field field)
    {
        if (field == null || field.getNComponents() < 1)
            return;
        this.inField = field;
        thresholdComponentChooser.setDataSchema(inField.getSchema());
        updateGUI();
    }

    private void updateThrSlider()
    {
        if(inField == null)
            return;        
        float minV = (float) inField.getComponent(thresholdComponentChooser.getComponent()).getPreferredMinValue();
        float maxV = (float) inField.getComponent(thresholdComponentChooser.getComponent()).getPreferredMaxValue();
        thresholdSlider.setMin(minV);
        thresholdSlider.setMax(maxV);
        thresholdSlider.setLowUp(minV, maxV);
    }

    private void updateGUI() {
        if(params == null || inField == null) {
            return;
        }
        
        thresholdComponentChooser.setComponent(params.getComponent());
        updateThrSlider();
        thresholdSlider.setLowUp(params.getLowerThreshold(), params.getUpperThreshold());
        lowValCheckBox.setSelected(params.isLowToMin());
        upValCheckBox.setSelected(params.isUpToMax());
        invalidateCB.setSelected(params.isInvalidate());        
    }

}
